--Initialize
init_mod("auth")

--Local
auth.default = "user"
auth.blockall = 0
auth.block = {}
local loginusgns = {}
auth.queue = {};

--Utilities

function util.findpattern(text, pattern, start)
	if (text) then
		return string.sub(text, string.find(text, pattern, start))
	else
		return -1
	end
end

function util.fileexists(n)
	local f=io.open(n)
	if (f ~= nil) then io.close(f) end
	return f~=nil
end

function util.addUser(user, usgn)
        file = io.open(conf_dir.."/users/"..usgn..".cfg", "w+")
        file:write(user.." user ;")
        file:close()
        file = io.open(conf_dir.."/users/"..user..".cfg", "w+")
        file:write("autologin "..usgn.." ;")
        file:close()
end

function util.changeUserPrivilege(usgn, priv)
	local user = ""
	        for line in io.lines(conf_dir.."/users/"..usgn..".cfg") do
	                if #line > 0 then
	                        local temp = {}
	                        for word in string.gmatch(line, "%w+") do
	                                table.insert(temp, word)
	                        end
	
	                        user = temp[1]
	                end
	        end

		file = io.open(conf_dir.."/users/"..usgn..".cfg", "w+")
		file:write(user.." "..priv.." ;")
		file:close()
end

function util.updateUserLastLogin(usgn)
	file = io.open(conf_dir.."/users/"..usgn.."-login.cfg", "w+")
	file:write(os.date("%d%b%Y"))
	file:close()
end

function util.changeUserPassword(user, pass, usgn)
        if user and pass and usgn then
                file = io.open(conf_dir.."/users/"..user..".cfg", "w+")
                file:write(pass.." "..usgn.." ;")
                file:close()
        end
end



--Act - Command "/login"
function act_relogin(p, typ, cmd)
        admins[p] = nil
        if (playeruid[p]) then userpid[playeruid[p]] = nil end
        playeruid[p] = nil
	act_autologin(p, typ, cmd)
end

function act_login(p, typ, cmd)
	if (auth.blockall > 0) then
		return invalid(p, typ, "All logins have been blocked for "..auth.blockall.." more seconds.")
	end

	cmd = string.split(cmd)
	local username = cmd[1]
	local password = cmd[2]
        local usgn = player(p, "usgn")
	local realpassword = ""
	local priv = ""

	if not cmd[1] or not cmd[2] or cmd[2] == "autologin" then
                return invalid(p, typ, "Correct usage: !login [username] [password]")
	end


	if not password then return invalid(p, typ, "Please enter the correct parameters") end
	if util.fileexists(conf_dir.."/users/"..username..".cfg") then
	        for line in io.lines(conf_dir.."/users/"..username..".cfg") do
	                if #line > 0 then
	                        local temp = {}
	                        for word in string.gmatch(line, "%w+") do
	                                table.insert(temp, word)
	                        end
	
	                        realpassword = temp[1]
				usgn = temp[2]
	                end
			break
	        end
	else
		return invalid(p, typ, "User \""..username.."\" does not exist")
	end

	if (realpassword == password) then
		if not util.fileexists(conf_dir.."/users/"..usgn..".cfg") then
			return
		end

                for line in io.lines(conf_dir.."/users/"..usgn..".cfg") do
                        if #line > 0 then
                                local temp = {}
                                for word in string.gmatch(line, "%w+") do
                                        table.insert(temp, word)
                                end

                                username = temp[1]
                                priv = temp[2]
				break
                        end
                end

		if (priv == "user") then
			return invalid(p, typ, "User \""..username.."\" does not exist")
		end

		if (auth.block[username] == nil) then auth.block[username] = 0 end
		if (auth.block[username] > 0) then
			return invalid(p, typ, "This login has been blocked for "..auth.block[username].." more seconds.")
		end

		admins[p] = priv

		if (admins[p] ~= "user") then
			msg2(p, "User \""..username.."\" logged in successfully, your privilege mask is \""..admins[p].."\"")
		end
		if (hye and hye.loginmessage) then
			msg2(p, hye.loginmessage)
		end
		userpid[username] = p
		playeruid[p] = username
		loginusgns[p] = usgn
			-- update user login date
		util.updateUserLastLogin(usgn)
	else
		return invalid(p, typ, "Incorrect Password for user \""..username.."\"")

	end

end

--Adm - Command "@register username usgnid"

function adm_register_superadmin(p, typ, cmd)

	cmd = string.split(cmd)
	local username = cmd[1]
	local usgnid = cmd[2]

        if not cmd[1] or not cmd[2] then
                return invalid(p, typ, "Correct usage: @register [username] [usgn id]")
        end

	if (string.find(username, '[^a-zA-Z0-9]') or string.find(usgnid, '[^0-9]')) then
		msg2(p, "Correct usage: @register [username] [usgn id]")
		return invalid(p, typ, "You can only use alphanumeric characters in your username and password!")
	end

	if not util.fileexists(conf_dir.."/users/"..usgnid..".cfg") then
		if util.fileexists(conf_dir.."/users/"..username..".cfg") then
			msg2(p, "The username: \""..username.."\" already exists")
			return
		end
		local usgn = usgnid
		if not usgn or usgn == 0 then return invalid(p, typ, "Cannot register without USGN!") end
		util.addUser(username, usgn)
		msg2(p, "User \""..username.."\" created successfully")
	else
		msg2(p, "USGN \""..usgnid.."\" already registered")
	end
end

--Admin Acts

function adm_authtype_vip(p, typ, cmd)
	msg2(p, "Your current access mask is \""..admins[p].."\"")
end

function adm_logout_vip(p, typ, cmd)
	admins[p] = nil
	if not (#cmd > 0) then
		msg2(p, "Successfully logged out from the account (\'"..playeruid[p].."\')")
	end
	userpid[playeruid[p]] = nil
	playeruid[p] = nil
	loginusgns[p] = nil
end

function adm_forcelogout_superadmin(p, typ, cmd)
	cmd = toTable(cmd)
	local i = tonumber(cmd[1])
	if (not i) then return invalid(p, typ, "Correct Usage: @forcelogout [playerid]") end
	if (not player(i, "exists")) then return invalid(p, typ, "Player does not exist!") end

	if (admins[i] == "superadmin") then
		return invalid(p, typ, "Cannot force-logout a superadmin!")
	end

	if (playeruid[i]) then
	        admins[i] = nil
	        msg2(i, player(i, "name").." (\'"..playeruid[i].."\') has been force-logged out")
	        userpid[playeruid[i]] = nil
	        playeruid[i] = nil
		loginusgns[i] = nil
		msg(sv.source_clr, player(p, "name").." used @forcelogout on "..player(i, "name")..".")
	else
		msg2(i, player(i, "name").." was not logged in.")
	end
end

function adm_forcelogoutall_superadmin(p, typ, cmd)
	for i = 1, 32, 1 do
		if (admins[i] ~= "superadmin") then
			if (playeruid[i]) then
				admins[i] = nil
				msg2(i, player(i, "name").." (\'"..playeruid[i].."\') has been force-logged out")
				userpid[playeruid[i]] = nil
				playeruid[i] = nil
				loginusgns[i] = nil
			end
		end
	end
	msg(sv.source_clr, player(p, "name").." used @forcelogoutall.")
end

function adm_forcerelogin_superadmin(p, typ, cmd)

        cmd = toTable(cmd)
	local i = tonumber(cmd[1])
        if (not i) then return invalid(p, typ, "Correct Usage: @forcerelogin [playerid]") end
        if (not player(i, "exists")) then return invalid(p, typ, "Player does not exist!") end

        admins[i] = nil
        if (playeruid[i]) then userpid[playeruid[i]] = nil end
        playeruid[i] = nil
        loginusgns[i] = nil

        act_autologin(i, typ, "")

        msg(sv.source_clr, player(p, "name").." used @forcerelogin on "..player(i, "name")..".")
end

function adm_forcelogin_superadmin(p, typ, cmd)
	cmd = toTable(cmd)
	local i = tonumber(cmd[1])
        if (not i) then return invalid(p, typ, "Correct Usage: @forcelogin [playerid]") end
        if (not player(i, "exists")) then return invalid(p, typ, "Player does not exist!") end

	act_autologin(i, typ, "")

	msg(sv.source_clr, player(p, "name").." used @forcelogin on "..player(i, "name")..".")
end

function adm_forceloginall_superadmin(p, typ, cmd)
	for i = 1, 32, 1 do
		act_autologin(i, typ, "")
	end
	msg(sv.source_clr, player(p, "name").." used @forceloginall.")
end



function adm_setpassword_superadmin(p, typ, cmd)

	local pass = cmd
	pass = string.sub(pass,0,string.len(pass)-1)
	if (string.find(pass, '[^a-zA-Z0-9]')) then
		return invalid(p, typ, "You can only use alphanumeric characters in your password!")
	end

	util.changeUserPassword(playeruid[p], pass, loginusgns[p])
	msg2(id, "Password successfully changed.")
end

function adm_listusers_admin1(p, typ, cmd)
	for i = 1, 32, 1 do
		if (playeruid[i]) then
			if (loginusgns[i]) then
				msg2(p, Color(255, 100, 0), i..". "..player(i,"name").." ("..player(i,"usgn")..") = "..playeruid[i].." ("..loginusgns[i]..") : "..admins[i])
			end
		end
	end
end

--[[function adm_listauthtype_superadmin(p, typ, cmd)
	cmd = toTable(cmd)
	if (not cmd[1]) then return invalid(p, typ, "Missing AuthType!") end

        for k, v in pairs(users) do
                if v.id and v.password and v.privilege and v.usgn and v.privilege == cmd[1] then
                	msg2(p, Color(255, 100, 0), "User: "..k.." USGN: "..v.usgn );
                end
        end
end--]]

--[[function adm_listallusers_superadmin(p, typ, cmd)
        for k, v in pairs(users) do
                if v.id and v.password and v.privilege and v.usgn then
                        msg2(p, Color(255, 100, 0), "User: "..k.." Privilege: "..v.privilege.." USGN: "..v.usgn );
                end
        end
end--]]


-- @blockadmin [playerid]
function adm_blockadmin_superadmin(p, typ, cmd)
	cmd = toTable(cmd) 
	local i = tonumber(cmd[1])
	local s = ""
	if (not player(i, "exists")) then return invalid(p, typ, "Player does not exist.") end
	if (is_admin(i)) then
		if (is_superadmin(i)) then return invalid(p, typ, "Access denied on superadmin.") end

	        s = s .. player(p, "name") .. " (" .. player(p, "usgn") .. ") = " .. playeruid[p] .." ("..loginusgns[p]..") "
        	s = s .. " used @stopadmin on "
	        s = s .. player(i, "name") .. " (" .. player(i, "usgn") .. ") = " .. playeruid[i] .." ("..loginusgns[i]..") " .."\n"

		auth.block[playeruid[i]] = 180
		admins[i] = nil
		userpid[playeruid[i]] = nil
		playeruid[i] = nil
		loginusgns[i] = nil
		parse("speedmod "..i.." 0")
		if (hye ~= nil) then hye.god[i] = nil end
	else
		return invalid(p, typ, "Player is not logged in.")
	end

	-- time only passes while player exists on server
        msg(sv.source_clr, player(i, "name").."'S LOGIN DISABLED FOR 3 MINUTES.")

        file = io.open(conf_dir.."stopadmin.cfg", "w+")
        file:write(s)
        file:close()

end

function adm_stopabuse_superadmin(p, typ, cmd)
	local userson = ""
        local s = ""
        s = s .. playeruid[p] .. " used @stopabuse\n"
        s = s .. "Players on at time of use:\n"
        for i = 1, 32, 1 do
                if (player(i,"exists") and playeruid[i]) then
                        if (loginusgns[i]) then
				userson = userson .. player(i, "name") .. " (" .. player(i, "usgn") .. ") = " .. playeruid[i] .." ("..loginusgns[i]..") " .. "\n"
				admins[i] = 0
			        userpid[playeruid[i]] = nil
			        playeruid[i] = nil
				loginusgns[i] = nil
				parse("speedmod "..i.." 0")
				if (hye ~= nil) then hye.god[i] = nil end
                        end
                end
        end

	auth.blockall = 180

	msg("255015015 ALL LOGINS DISABLED FOR 3 MINUTES.@C")
        msg("255015015 PLEASE STOP ABUSING ADMIN!@C")

	s = s .. userson

        file = io.open(conf_dir.."stopabuse.cfg", "w+")
        file:write(s)
        file:close()

end


--Adm - Command "@auth_remove username"
function adm_authremove_superadmin(p, typ, cmd)
	if #cmd == 0 then msg2(p, "Please enter a username"); return nil end
	cmd = toTable(cmd)
	local username = cmd[1]
	local usgn = 0

	if util.fileexists(conf_dir.."/users/"..username..".cfg") then
                for line in io.lines(conf_dir.."/users/"..username..".cfg") do
                        if #line > 0 then
                                local temp = {}
                                for word in string.gmatch(line, "%w+") do
                                        table.insert(temp, word)
                                end

                                usgn = temp[2]
                        end
                        break
                end

		--remove files
		os.remove(conf_dir.."/users/"..username..".cfg")
		if util.fileexists(conf_dir.."/users/"..usgn.."-login.cfg") then
			os.remove(conf_dir.."/users/"..usgn.."-login.cfg")
		end
		if util.fileexists(conf_dir.."/users/"..usgn..".cfg") then
			os.remove(conf_dir.."/users/"..usgn..".cfg")
		end

		--force user to logout
		if userpid[usgn] then
			local i = userpid[usgn]
			admins[i] = nil
			userpid[usgn] = nil
			playeruid[p] = nil
		end

		msg2(p, "User \""..username.."\" removed successfully")
	else
		msg2(p, "User \""..username.."\" does not exist")
	end
end

function act_usgn(p, typ, cmd)
	local i = p
	local usgn = player(i, "usgn")

	if usgn and usgn ~= 0 then
		msg2(p,Color(255, 100, 0), "Your USGN is "..usgn)
	else
		msg2(p, Color(255, 100, 0), "You are not logged into USGN!")
	end
end

--Hooks


function act_autologin(p, typ, cmd)
	local username = ""
	local priv = ""
	local usgn = player(p, "usgn")
	if usgn and usgn ~= 0 then
		if not util.fileexists(conf_dir.."/users/"..usgn..".cfg") then
			return
		end

                for line in io.lines(conf_dir.."/users/"..usgn..".cfg") do
                        if #line > 0 then
                                local temp = {}
                                for word in string.gmatch(line, "%w+") do
                                        table.insert(temp, word)
                                end

                                username = temp[1]
                                priv = temp[2]
                                break
                        end
                end

                if (auth.blockall > 0) then
			if (priv == "user") then
				return
			end
                        return invalid(p, typ, "All logins have been blocked for "..auth.blockall.." more seconds.")
                end

                if (auth.block[username] == nil) then auth.block[username] = 0 end
                if (auth.block[username] > 0) then
                        if (priv == "user") then
                                return
                        end
                        return invalid(p, typ, "This login has been blocked for "..auth.block[username].." more seconds.")
                end

                admins[p] = priv

                if (admins[p] ~= "user") then
                        msg2(p, "User \""..username.."\" logged in successfully, your privilege mask is \""..admins[p].."\"")
                end
                if (admins[p] ~= "user" and hye and hye.loginmessage) then
                        msg2(p, hye.loginmessage)
                end
                userpid[username] = p
                playeruid[p] = username
		loginusgns[p] = usgn
                        -- update user login date
                util.updateUserLastLogin(usgn)
	end
end

function hook_init_auth()
	for k, v in pairs(cmd_priv) do
		for k1, v1 in pairs(v) do
			if not priv_cmd[v1] then priv_cmd[v1] = {} end
			priv_cmd[v1][k] = k
		end
	end
end

function hook_second_auth()
	if (auth.blockall > 0) then auth.blockall = auth.blockall - 1 end
	for k,v in pairs(auth.block) do
		if (v > 0) then
			auth.block[k] = v - 1
		end
	end
	for k,v in pairs(auth.queue) do
		if (v > 0) then
			auth.queue[k] = v - 1
		else
			auth.queue[k] = nil
			pop_queue(k)
		end
	end
end

function pop_queue(p)
	local iprange = player(p, "ip")
	iprange = util.findpattern(iprange, "[0-9]*[^0-9][0-9]*[^0-9]")
	if util.fileexists(conf_dir.."/banned/"..iprange.."cfg") then
		if (player(p, "usgn") > 0 and util.fileexists("/root/whitelist/"..player(p, "usgn")..".cfg")) then
			print(player(p, "name") .. " is in the whitelist. Auto-kick bypassed.")
		else
			print(player(p, "name") .. " kicked because his IP " .. player(p, "ip") .. " is in banned range "..iprange.."*")
			--msg2(p, "You have been banned.")
			parse("kick "..p)
			--parse("banip "..iprange.."*.*")
			return
		end
	end
	if (playeruid[p]) then userpid[playeruid[p]] = nil end
	playeruid[p] = nil
	admins[p] = nil
	act_autologin(p)
end

function hook_join_auth(p)
	auth.queue[p] = 2
end

function hook_leave_auth(p, t)
	if auth.queue[p] then auth.queue[p] = nil end
	if not playeruid[p] then return invalid() end
	userpid[playeruid[p]] = nil
        playeruid[p] = nil
        admins[p] = nil
end

toMod(auth.name)
